package com.liang.service;

import com.liang.entity.SysPermissionInfo;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.List;
import java.util.Map;

/**
 * (SysPermissionInfo)表服务接口
 *
 * @author makejava
 * @since 2023-02-19 21:37:38
 */
public interface SysPermissionInfoService {

    /**
     * 通过ID查询单条数据
     *
     * @param permissionId 主键
     * @return 实例对象
     */
    SysPermissionInfo queryById(String permissionId);

    /**
     * 分页查询
     *
     * @param sysPermissionInfo 筛选条件
     * @param pageRequest       分页对象
     * @return 查询结果
     */
    Page<SysPermissionInfo> queryByPage(SysPermissionInfo sysPermissionInfo, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param sysPermissionInfo 实例对象
     * @return
     */
    int insert(SysPermissionInfo sysPermissionInfo);

    /**
     * 修改数据
     *
     * @param sysPermissionInfo 实例对象
     * @return 实例对象
     */
    int update(SysPermissionInfo sysPermissionInfo);

    /**
     * 通过主键删除数据
     *
     * @param permissionId 主键
     * @return 是否成功
     */
    boolean deleteById(String permissionId);

    /**
     * 获取菜单
     *
     * @param userId
     * @return
     */
    List<Map> menuInit(int userId);


    /**
     * 查询菜单列表
     */
    List<SysPermissionInfo> list();

    /**
     * 获取权限列表
     *
     * @return
     */
    List<Map<String, Object>> listPermission();

    /**
     * 禁用
     *
     * @param permissionId
     * @return
     */
    int forbid(String permissionId);

    /**
     * 启用
     *
     * @param permissionId
     * @return
     */
    int enable(String permissionId);

    /**
     * 修改菜单顺序
     *
     * @param sysPermissionInfo
     * @return
     */
    int updateSort(SysPermissionInfo sysPermissionInfo);

    /**
     * 权限检查
     *
     * @param sign
     * @param userId
     * @return
     */
    int checkPermission(String sign, Integer userId);
}
